program HMO
!   Hueckel MO Program v.1.2  fortran 90
!                                written by H. Kihara

implicit none

character(len=40) title
integer na   !   q
integer np   !   dq
integer nb   !   
integer nh   !   wevf
integer, allocatable, dimension(:) :: ib    !   ib, jb  ΁iאڍsj
integer, allocatable, dimension(:) :: jb
real, allocatable,dimension(:, :)  :: g     !   iNs
real, allocatable,dimension(:, :)  :: v     !   ŗLxNg
integer i, j, k
real t 

write(*,'(a40,/)') '  ***  Hueckel MO Calculation  ***'
read(*,*) title
write(*,'(1x,a40)') title
read(*,*) na, nb, np, nh
write(*,'(1x,i4,a8,i4,a8,/)') na,' atoms',nb,' bonds'

!  s̊m
allocate( ib(nb) )
allocate( jb(nb) )
allocate( g(na, na) )
allocate( v(na, na) )

!  s̏
g = 0.0
v = 0.0

!   iNs̑gݗ
!   Ă錴q̔ԍ̑g Cŋ؂ē͂

do k = 1, nb
	read(*,*) ib(k), jb(k)
	g(ib(k),jb(k)) = 1.0
	g(jb(k),ib(k)) = 1.0
end do
      
 !  wej܂ޏꍇ
 !  ύXsvf̔ԍƗvfiweEp[^j@Cŋ؂ē͂

if (nh.gt.0) then
	do k = 1, nh
		read(*,*) i, j, t
		g(i,j) = t
		g(j,i) = t
	end do            
end if
      
call diag()                  ! Rr@ɂΊp

call incre()                 ! ŗLl̏ɕוς

call pout()                  ! ʂ̈

contains

subroutine diag()

!   Rr@ɂs̑Ίp

real, parameter :: dl = 0.000001
integer :: it = 0
integer i, j, k, l
real d, sm, gj, gk, gkl, gjl, ta, tb, cs, sn, vj, vk

do i = 1, na
	v(i,i) = 1.0
end do

call getmax(d)

do while (d > dl) 
      
	sm = 0.1*d
	it = it + 1

	do j = 2, na
		do k = 1, j-1

			if (abs(g(j,k)) .gt. sm) then
				gj = g(j,j)
				gk = g(k,k)
				tb = (gj-gk)/(2*g(k,j))

				if (tb .le. 0.) then
					ta = tb - sqrt(1+tb*tb)
				else
					ta = tb + sqrt(1.0+tb*tb)
				end if

				cs = 1.0/sqrt(1.0+ta*ta)
				sn = cs*ta

				do l = 1, na

					if (l .eq. k) then
						g(k,k) = gk*cs*cs+g(j,k)*2*sn*cs+gj*sn*sn
						g(j,j) = gk+gj-g(k,k)
					else if (l .ne. j) then
						gkl = g(k,l)
						gjl = g(j,l)
						g(k,l) = gkl*cs+gjl*sn
						g(j,l) = gjl*cs-gkl*sn
						g(l,k)  =g(k,l)
						g(l,j) = g(j,l)
					end if

				end do

				g(j,k) = g(j,k)*(cs*cs-sn*sn)+(gj-gk)*sn*cs
				g(k,j) = g(j,k)

				do i = 1, na
					vj = v(i,j)
					vk = v(i,k)
					v(i,j) = vj*cs-vk*sn
					v(i,k) = vj*sn+vk*cs
				end do
 
			end if

		end do

	end do

	call getmax(d)
 
end do       ! of while


return
end subroutine diag

subroutine getmax(d)

!   Ίpvf̍ől߂

real d
integer i, j

d = abs(g(2,1))

do i = 2, na
	do j = 1, i-1
		if (abs(g(i,j)) > d) then
			d = abs(g(i,j))
		end if
	end do
end do

return
end subroutine getmax

subroutine incre()
      
!   ŗLxNgŗLl̏ɕׂ

integer i, j, imax
real emax, t

do i=1, na
	emax = g(i,i)
        imax = i
        
        do j = i, na
		if (g(j,j) > emax) then
			imax = j
			emax = g(j,j)
		end if
        end do
  
        if (i < imax) then
			t = g(i,i)
			g(i,i) = g(imax,imax)
			g(imax,imax) = t

			do j = 1, na
				t = v(j, i)
				v(j, i) = v(j, imax)
				v(j, imax) = t
			end do

        end if
        
end do

return
end subroutine incre

subroutine pout()
       
integer, parameter :: column = 8
integer l
integer ::  k = 1
integer ::  j = column

write(*,'(a40,/)') ' -- eigenvalues and eigenvectors -- '

do while (k <= na) 

        if (j > na) then
			j = na
        end if

        write(*, '(2x,8f9.4)') (g(i,i), i = k, j)
        write(*, '(1x)')
	
        do i = 1, na
			write(*, '(i2,8f9.4)')  i, (v(i,l), l=k, j)
		end do

		write(*,'(/)')

        k = j + 1
        j = k + column -1
		
end do

return
end subroutine pout

end program HMO

